/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.create.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.partitionmapping.PartitionMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskgraph.AbstractTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.abstractmapping.AbstractTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.FailSilentTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.FailSilentTaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.create.Creates;

import com.google.inject.Provides;

/**
 * Creator of random task mappings for fail-silent execution model
 * 
 * @author diewald
 */
public class FailSilentTaskMappingCreator extends
		TaskMappingCreator<FailSilentTaskMappingEntry, FailSilentTaskMappingEncoding> {

	/**
	 * Creates a {@link FailSilentTaskMappingEncoding} aligned with the given
	 * {@link AbstractTaskMappingEncoding}. It contains only tasks backed by an implementation.
	 */
	@Provides
	@Creates
	public FailSilentTaskMappingEncoding create(AbstractTaskGraphEncoding atgEnc,
			AbstractTaskMappingEncoding atmEnc, PartitionMappingEncoding partEnc) {
		return new FailSilentTaskMappingEncoding(partEnc, atgEnc, atmEnc);
	}

	/** {@inheritDoc} */
	@Override
	public FailSilentTaskMappingEncoding create() {
		// TODO Auto-generated method stub
		return null;
	}
}
